image: python:3.8


stages:
  - QC
  - Docker
  - deploy

lint:
  stage: QC
  allow_failure: true
  script:
    # ставим плагин для flake8, который за собобой тянет flake8 и запускаем линт
    - pip3 install wemake-python-styleguide==0.15.2
    - cd app
    - flake8 .

pytest:
  stage: QC
  script:
    - apt update
    # утилита для catalyst
    - apt install -y libgl1-mesa-glx
    - cd app
    # ставим зависимости
    - pip install -r requirements.txt
    - export PYTHONPATH=.
    # прокидываем авторизацию и пуллим dvc
    - mkdir -p .dvc/tmp
    - cp $gdrive_user .dvc/tmp/gdrive-user-credentials.json
    - dvc pull
    # запускаем тесты
    - python -m pytest

service:
  stage: Docker
  image: docker
  variables:
    IMAGE_NAME: "registry.gitlab.com/ksenia/service:$CI_COMMIT_REF_NAME"
    DOCKER_HOST: tcp://docker:2375
  services:
    - docker:20.10.5-dind
  script:
  # прокидываем авторизацию с dvc с dvc
  - mkdir -p app/.dvc/tmp
  - cp $gdrive_user app/.dvc/tmp/gdrive-user-credentials.json
  # Логинимся, пуллим, и пушим два раза имедж с разным тегом
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  - docker pull $CI_REGISTRY_IMAGE:latest || true
  - docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .
  - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  - docker push $CI_REGISTRY_IMAGE:latest


deploy:
  image: ubuntu
  stage: deploy
  variables:
    docker: /usr/bin/docker
  script:
    # ставим утилиты
    - apt-get update
    - apt install -y --fix-missing openssh-client
    - apt-get install -y sshpass
    # подключаем впн
    - which openvpn || (apt-get update -y -qq && apt-get install -y -qq openvpn) # Install openvpn if not available.
    - cat <<< $CLIENT_OVPN > /etc/openvpn/client.conf # Move vpn config from gitlab variable to config file.
    - cat <<< "log /etc/openvpn/client.log" >> /etc/openvpn/client.conf # Tell vpn config to use log file.
    - openvpn --config /etc/openvpn/client.conf --daemon # Start openvpn with config as a deamon.
    - sleep 30s # Wait for some time so the vpn can connect before doing anything else.
    # добавляем наш хост в конфиг
    - cat /etc/openvpn/client.log
    - 'which ssh-agent'
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    # Поключаемся к компьютеру и запускаем наше приложение в Docker
    - sshpass -p $password ssh -tt $login@$ip "ls && mkdir -p app && cd app && docker logout && docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY && docker pull $CI_REGISTRY_IMAGE:latest && docker run -d -p 1234:5000 --name rainforest_service $CI_REGISTRY_IMAGE:latest && exit"
#    - sshpass -p $password ssh -tt $login@$ip $(ls && mkdir -p app && cd app && echo $CI_REGISTRY && docker logout && docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY && docker pull $CI_REGISTRY_IMAGE:latest && docker stop rainforest_service && docker rm rainforest_service && docker run -d -p 1234:5000 --name rainforest_service registry.gitlab.com/ksenia/rainforest_service:1.0 && exit)

#